<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import type { WorkflowCredentialsIn, WorkflowOut } from "@/client/types.gen";
import { onMounted, ref, reactive } from "vue";
import { Modal, Toast } from "bootstrap";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import DeleteModal from "@/components/modals/DeleteModal.vue";
import { GitRepository } from "@/utils/GitRepository";
import { useWorkflowStore } from "@/stores/workflows";
import BootstrapToast from "@/components/BootstrapToast.vue";

const workflowRepository = useWorkflowStore();
// Constants
// =============================================================================
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

// Bootstrap Elements
// =============================================================================
let updateCredentialsModal: Modal | null = null;
let successToast: Toast | null = null;

// Form Elements
// =============================================================================
const credentialsUpdateForm = ref<HTMLFormElement | undefined>(undefined);
const credentialsInputElement = ref<HTMLInputElement | undefined>(undefined);

// Props
// =============================================================================
const props = defineProps<{
  modalId: string;
  workflow: WorkflowOut;
}>();

// Reactive State
// =============================================================================
const credentials = reactive<WorkflowCredentialsIn>({
  token: "",
});

const formState = reactive<{
  loading: boolean;
  validated: boolean;
  updateCredentials: boolean;
  error: boolean;
}>({
  loading: false,
  validated: false,
  updateCredentials: true,
  error: false,
});

// Functions
// =============================================================================
function resetForm() {
  credentials.token = "";
}

function modalClosed() {
  formState.validated = false;
  credentialsInputElement.value?.setCustomValidity("");
  formState.error = false;
  resetForm();
}

function updateCredentials() {
  formState.validated = true;
  formState.error = false;
  credentialsInputElement.value?.setCustomValidity("");
  if (credentialsUpdateForm.value?.checkValidity()) {
    const repo = GitRepository.buildRepository(
      props.workflow.repository_url,
      props.workflow.versions[0].workflow_version_id,
      credentials.token,
    );
    formState.loading = true;
    repo
      .checkRepoAvailability()
      .then((result: boolean) => {
        if (result) {
          workflowRepository
            .updateWorkflowCredentials(props.workflow.workflow_id, credentials)
            .then(() => {
              formState.updateCredentials = true;
              successToast?.show();
              updateCredentialsModal?.hide();
            })
            .catch((error) => {
              console.error(error);
            });
        } else {
          formState.error = true;
          credentialsInputElement.value?.setCustomValidity(
            "Can't access repository.",
          );
        }
      })
      .finally(() => {
        formState.loading = false;
      });
  }
}

function deleteCredentials() {
  formState.loading = true;
  workflowRepository
    .deleteWorkflowCredentials(props.workflow.workflow_id)
    .then(() => {
      formState.updateCredentials = false;
      successToast?.show();
      updateCredentialsModal?.hide();
    })
    .catch((error) => {
      console.error(error);
    })
    .finally(() => {
      formState.loading = false;
    });
}

// Lifecycle Events
// =============================================================================
onMounted(() => {
  updateCredentialsModal = new Modal("#" + props.modalId);
  successToast = new Toast("#successToast-" + randomIDSuffix);
});
</script>

<template>
  <DeleteModal
    v-if="props.workflow.private"
    :modal-id="'delete-credentials-modal' + randomIDSuffix"
    :object-name-delete="'credentials for workflow ' + props.workflow.name"
    :back-modal-id="modalId"
    @confirm-delete="deleteCredentials()"
  />
  <bootstrap-toast :toast-id="'successToast-' + randomIDSuffix">
    Successfully updated credentials
  </bootstrap-toast>
  <bootstrap-modal
    :modal-id="modalId"
    :static-backdrop="true"
    modal-label="Update Workflow Version Icon Modal"
    size-modifier-modal="lg"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header>
      Update git repository credentials for Workflow
      <span class="fw-bold">{{ props.workflow.name }}</span>
    </template>
    <template v-if="props.workflow.private" #extra-button>
      <button
        class="btn delete-icon px-1"
        data-bs-toggle="modal"
        :data-bs-target="'#delete-credentials-modal' + randomIDSuffix"
      >
        <font-awesome-icon icon="fa-solid fa-trash" />
      </button>
    </template>
    <template #body>
      <form
        id="credentialsUpdateForm"
        ref="credentialsUpdateForm"
        :class="{ 'was-validated': formState.validated }"
      >
        <label for="workflowCredentialsInput" class="form-label"
          >New Token</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-key" />
          </div>
          <input
            id="workflowCredentialsInput"
            ref="credentialsInputElement"
            v-model="credentials.token"
            type="password"
            class="form-control"
            aria-describedby="iconHelp"
            required
          />
        </div>
        <div v-if="formState.error" class="text-danger">
          Can't access the repository.
        </div>
        <div class="card card-body mt-3">
          <h5>GitHub</h5>
          <p>
            For private GitHub repositories, CloWM needs a Personal Access Token
            (classic) with the scope <code>repo</code>.<br />
            Read this
            <a
              target="_blank"
              href="https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/managing-your-personal-access-tokens#creating-a-personal-access-token-classic"
              >Tutorial</a
            >
            on how to create such a token.
          </p>
          <h5>GitLab</h5>
          <p>
            For private GitLab repositories, CloWM needs a Project Access Token
            with the <code>read_api</code> scope and at least
            <code>Reporter</code> role.<br />
            Read this
            <a
              target="_blank"
              href="https://docs.gitlab.com/ee/user/project/settings/project_access_tokens.html#create-a-project-access-token"
              >Tutorial</a
            >
            on how to create such a token.
          </p>
          <p>
            Select a distant expiration date for both providers to ensure that
            there won't be any problems in the short future.
          </p>
        </div>
      </form>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        type="submit"
        form="credentialsUpdateForm"
        class="btn btn-primary"
        :disabled="formState.loading"
        @click.prevent="updateCredentials"
      >
        <span
          v-if="formState.loading"
          class="spinner-border spinner-border-sm"
          role="status"
          aria-hidden="true"
        ></span>
        Save
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped>
img {
  max-height: 64px;
  max-width: 64px;
}

.delete-icon {
  color: var(--bs-secondary) !important;
}

.delete-icon:hover {
  color: var(--bs-danger) !important;
}
</style>
